



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android --AsyncTask异步任务（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android --AsyncTask异步任务（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 06:44:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1.为什么要异步任务</p>
<ul><li>Android单线程模式</li>
<li>耗时操作放在非主线程（UI线程）中执行</li></ul>
<p>　　我们都知道Android是单线程模式，只有主线程才能对UI操作，简称UI线程。当然这样的好处是：保证UI的稳定性、准确性，避免多线程同时对UI的操作，导致UI的混乱<br />		　　但同时Android是一个多线程的操作系统，不可能把全部的事情放在主线程。如果任务堵塞，当时间过长，会抛出<strong>ANR（Application Not Responding）</strong>错误。</p>
<p>2.AsyncTask为何而生</p>
<ul><li>子线程中更新UI</li>
<li>封装、简化异步操作</li></ul>
<p>3.构建AsyncTask子类的参数<br />	　　AsyncTask&lt;Params,Progress,Result&gt;是一个抽象类，通常用于被继承，继承AsyncTask需要指定如下三个泛型参数：</p>
<ul><li>Params : 启动任务时输入参数的类型。</li>
<li>Progress : 后台任务执行中返回进度值的类型</li>
<li>Result : 后台执行任务完成后返回结果的类型</li></ul>
<p>4.构建AsyncTask子类的回调方法</p>
<ul><li><strong>doInBackground</strong> : 必须重写，异步执行后台程序将要完成的任务。</li>
<li><strong>onPreExecute</strong> : 执行后台耗时操作前被调用，通常用户完成一些初始化操作。</li>
<li><strong>onPostExecute</strong> : 当doInBackground() 完成后，系统自动调用onPostExecute()方法，并将doInBackground方法返回的值传给该方法</li>
<li><strong>onProgressUpdate</strong> : 在doInBackground() 方法调用publishProgress() 方法更新任务的执行进度后，就会触发该方法</li></ul>
<p>现在我们来写一个测试类：<strong><br /></strong></p>
<div>
<pre class="prettyprint linenums">import android.os.AsyncTask;<br />
import android.util.Log;

public class AsyncTaskTest extends AsyncTask&lt;Void, Void, Void&gt;{

    @Override<br />
    protected Void doInBackground(Void... params) {

        Log.i("Task", "doInbackgroun");<br />
        return null;<br />
    }

    @Override<br />
    protected void onPostExecute(Void result) {

        Log.i("Task", "onPostExecute");<br />
        super.onPostExecute(result);<br />
    }

    @Override<br />
    protected void onPreExecute() {

        Log.i("Task", "onPreExecute");<br />
        super.onPreExecute();<br />
    }

    @Override<br />
    protected void onProgressUpdate(Void... values) {

        Log.i("Task", "onProgressUpdate");<br />
        super.onProgressUpdate(values);<br />
    }<br />
}</pre>
</div>
<p><strong>在MainActivity中引用：</strong></p>
<div>
<pre class="prettyprint linenums">protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);<br />
        setContentView(R.layout.activity_main);<br />
        AsyncTaskTest task = new AsyncTaskTest();<br />
        task.execute();<br />
    }</pre>
</div>
<p>当我们运行在模拟器上时：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1063592/201612/1063592-20161205195241069-198763867.png" /><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1063592/201612/1063592-20161205195336101-324271317.png" /></p>
<p>根据上面的第四条所写，我们在doInBackground中调用publshProgress方法,运行后发现多了一个onProgressUpdate</p>
<div>
<pre class="prettyprint linenums">protected Void doInBackground(Void... params) {

        Log.i("Task", "doInbackgroun");<br />
        publishProgress(params);<br />
        return null;<br />
    }</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1063592/201612/1063592-20161205195628444-1442585134.png" /></p>
<p>谢谢大家的关注。<strong>I love you not for who you are, but for who I am before you.</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8koj3qj.html">Linux平台 Oracle 10gR2（10&period;2&period;0&period;5）RAC安装 Part2：clusterware安装和升级</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zv4519.html">转：浅谈UNIX下Apache的MPM及httpd&period;conf配置文件中相关参数配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkp1rq.html">JVM简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ooole8.html">移动端web app自适应布局探索与总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4l5xe8.html">javascript 的默认对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o3krv9.html">System V共享内存区</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xp2yz8.html">android 启动第三方程序的代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm40w09.html">Python流程控制语句（Control Flow）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vjojo8.html">UML精粹学习 - 订单类结构图</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjxgz79.html">HDU 4441 Queue Sequence</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmy4y49.html">LayoutInflater作用及使用--自定义EditText，自带清除内容按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdr2rd8.html">SQL 里面的COALESCE函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okejxx9.html">使用ntfs的磁盘映射功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydm1ogq.html">c&plus;&plus;中的名字查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo1x5nq.html">小心LinkedHashMap的get&lpar;&rpar;方法（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdgd149.html">Ext秒表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwwrx9.html">英语词典Alpha版本发布说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey74zk9.html">利用Python爬取可用的代理IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1g5yoq.html">fastadmin表单验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25d0vwq.html">linux配置虚拟机的网络服务</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/g8eo0xeq.html">build&period;fxbuild打不开 Failed to create the part&amp;&num;39&semi;s controls</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o5vz59.html">Security &amp;&num;187&semi;  Authorization &amp;&num;187&semi;  基于视图的授权</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxee0z8.html">Swift函数的定义</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdok578.html">&lpar;47&rpar; odoo详细操作手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mpy7p8.html">深入剖析tomcat 笔记&mdash;&mdash;第8章 载入器</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw04vk9.html">maven webjar构建及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jpdl09.html">C语言实现四则运算</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4n31n9.html">ionic 通过PouchDB ＋ SQLite来实现app的本地存储（Local Storage）</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw0x2y9.html">MD5加密代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyrjmx8.html">初始化git远程仓库步骤</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
